  function nombrePtMesh obj =
  (
    meshOp.getNumVerts obj
  )
  function nombrePtPoly obj =
  (
    polyOp.getNumVerts obj
  )
  function getPtMesh obj w =
  (
    meshOp.getVert obj w
  )
  function getPtPoly obj w =
  (
    polyOp.getVert obj w node:obj
  )
  function setPtMesh obj w poi =
  (
  	meshOp.setVert obj w poi
  )
  function setPtPoly obj w poi = 
  (
  	polyOp.setVert obj w poi node:obj
  )

  function getNumberCandidates dist_mini objet_cible =
  (
    obj = selection[1]
	if obj == undefined do return "select an object first"
	nombrePoints = #(nombrePtMesh, nombrePtPoly)
	getPoint = #(getPtMesh, getPtPoly)
	tipObj = 1
	tipCible = 1
	if classOf(objet_cible.baseObject) == Editable_Poly do (
	   tipCible = 2
	   )
	if classOf(obj.baseObject) == Editable_Poly do (
	   tipObj = 2
	   )
    nb = 0
	for v = 1 to nombrePoints[tipCible] objet_cible do
	    (
	      vert1 = getPoint[tipCible] objet_cible v
	      for w = 1 to nombrePoints[tipObj] obj do
	      (
	        vert2 = getPoint[tipObj] obj w
			dis = distance vert2 vert1
			--print dis
	        if dis > 0 and dis < dist_mini do nb += 1
	      )
	    )
	    "will snap: "+(nb as String)+" points"
	  
  ) -- function def
  
  utility snapToObject "Snap to Object"
(
  local thres_amt = 0.01
  local objet_cible = undefined
  local cur_objet = undefined
  
  pickbutton pickTarget "Pick Target Object" 
  spinner thres "Threshold:" range:[0.0,2.0,0.01] type:#float scale:0.005
  label nbSnapped ""
  button lancer "Snap"

  on isEnabled do return selection.count == 1
    
  on pickTarget picked obj2 do 
  (
    if obj2 != undefined do
    (
      objet_cible = obj2
      -- calculer le nombre des candidates 
      nbcand = getNumberCandidates thres_amt objet_cible
      nbSnapped.text = nbcand
      pickTarget.text = obj2.name
    )
  )
  
  on thres changed val do 
  (
    thres_amt = val
	if objet_cible != undefined do
	(
      nbcand = getNumberCandidates thres_amt objet_cible
      nbSnapped.text = nbcand
	  )
  )
    
  on lancer pressed do
  (
    if selection.count == 1 and objet_cible != undefined do 
    (
    obj = selection[1] 
	nombrePoints = #(nombrePtMesh, nombrePtPoly)
	getPoint = #(getPtMesh, getPtPoly)
	setPoint = #(setPtMesh, setPtPoly)
	tipObj = 1
	tipCible = 1
	if classOf(objet_cible.baseObject) == Editable_Poly do (
	   tipCible = 2
	   )
	if classOf(obj.baseObject) == Editable_Poly do (
	   tipObj = 2
	   )
    nb_snap = 0
	undo on (
		for v = 1 to nombrePoints[tipCible] objet_cible do
		(
	      vert1 = getPoint[tipCible] objet_cible v
	      for w = 1 to nombrePoints[tipObj] obj do
	      (
	        vert2 = getPoint[tipObj] obj w
			dis = distance vert2 vert1
	        if dis > 0 and dis < thres_amt do 
			(
		        vert2.x = vert1.x
		        vert2.y = vert1.y
		        vert2.z = vert1.z
		        setPoint[tipObj] obj w vert2
		        nb_snap += 1
	        )
	
	      )
	    )
	
	    update obj
	)
	nbSnapped.caption = "snapped: "+(nb_snap as String)+" points"
	pickTarget.caption = "Pick Target Object"
    )
  )
  
)